local GlobalAddonName, ExRT = ...

local GetTime, UnitIsFriendlyByUnitFlag, UnitInRaid, UnitName, UnitGUID, UnitIsPlayerOrPet, string_sub, table_wipe = GetTime, ExRT.mds.UnitIsFriendlyByUnitFlag, UnitInRaid, UnitName, UnitGUID, ExRT.mds.UnitIsPlayerOrPet, string.sub, ExRT.mds.table_wipe

local module = ExRT.mod:New("BossWatcher",ExRT.L.panelBossWatcher)
module.db.guidsList = {}
module.db.fightData = {}
module.db.fightData.damage = {}
module.db.encounterName = nil
module.db.encounterStart = 0
module.db.encounterStartGlobal = 0
module.db.encounterEnd = 0
module.db.fightData.switch = {}
module.db.fightData.npc_cast = {}
module.db.fightData.interrupts = {}
module.db.fightData.dispels = {}
module.db.fightData.buffs = {}
module.db.fightData.dies = {}
module.db.lastFightID = 0
module.db.timeFix = nil
local fightUV = nil

module.db.buffsFilters = {
[1] = {
	[-1]=ExRT.L.panelBossWatcherFilterTaunts,
	[62124]=true,	--Paladin
	[130793]=true,	--Monk pet
	[17735]=true,	--Warlock pet
	[97827]=true,	--Warlock
	[56222]=true,	--DK
	[51399]=true,	--DK
	[49560]=true,	--DK
	[6795]=true,	--Druid
	[355]=true,	--Warrior
	[115546]=true,	--Monk
	[116189]=true,	--Monk
},
[2] = {[-1]=ExRT.L.panelBossWatcherFilterOnlyBuffs,}, --> Only buffs
[3] = {[-1]=ExRT.L.panelBossWatcherFilterOnlyDebuffs,}, --> Only debuffs
[4] = {[-1]=ExRT.L.panelBossWatcherFilterBySpellID,}, --> By spellID
[5] = {
	[-1]=ExRT.L.panelBossWatcherFilterLagFix,
	[47753]=true,
	[137596]=true,
	[86273]=true,
	[105284]=true,
},
[6] = {
	[-1]=ExRT.L.panelBossWatcherFilterStun,
	[853]=true,	[105593]=true,	[91797]=true,	[408]=true,	[119381]=true,	
	[89766]=true,	[118345]=true,	[46968]=true,	[107570]=true,	[5211]=true,	
	[44572]=true,	[119392]=true,	[122057]=true,	[113656]=true,	[108200]=true,	
	[108194]=true,	[30283]=true,	[118905]=true,	[20549]=true,	[119072]=true,	
	[115750]=true,
},
[7] = {
	[-1]=ExRT.L.panelBossWatcherFilterPersonal,
	[148467]=true,	[31224]=true,	[110788]=true,	[55694]=true,	[47585]=true,	
	[31850]=true,	[115610]=true,	[122783]=true,	[642]=true,	[5277]=true,	
	[118038]=true,	[104773]=true,	[115176]=true,	[48707]=true,	[1966]=true,	
	[61336]=true,	[120954]=true,	[871]=true,	[106922]=true,	[30823]=true,	
	[6229]=true,	[22812]=true,	[498]=true,
},
}
module.db.buffsFilterStatus = {}

module.db.raidIDs = {
	[604]=true, 	--wotlk
	[543]=true, 	--wotlk
	[535]=true, 	--wotlk
	[529]=true, 	--wotlk
	[527]=true, 	--wotlk
	[532]=true, 	--wotlk
	[531]=true, 	--wotlk
	[609]=true, 	--wotlk
	[718]=true,	--wotlk

	[752]=true,	--BH
	[754]=true,	--BD
	[758]=true,	--BoT
	[774]=true,	--TotFW
	[800]=true,	--FL

	[824]=true,	--DS
	[896]=true,	--MV
	[897]=true,	--HoF
	[886]=true,	--ToES
	[930]=true,	--ToT
	[953]=true,	--SoO
}
--/dump select(6,EJ_GetInstanceInfo())

module.db.autoSegmentEvents = {"UNIT_SPELLCAST_SUCCEEDED","SPELL_AURA_REMOVED","SPELL_AURA_APPLIED","UNIT_DIED","CHAT_MSG_RAID_BOSS_EMOTE"}
module.db.autoSegmentEventsL = {
	["UNIT_SPELLCAST_SUCCEEDED"] = ExRT.L.panelBossWatcherSegmentEventsUSS,
	["SPELL_AURA_REMOVED"] = ExRT.L.panelBossWatcherSegmentEventsSAR,
	["SPELL_AURA_APPLIED"] = ExRT.L.panelBossWatcherSegmentEventsSAA,
	["UNIT_DIED"] = ExRT.L.panelBossWatcherSegmentEventsUD,
	["CHAT_MSG_RAID_BOSS_EMOTE"] = ExRT.L.panelBossWatcherSegmentEventsCMRBE,
}
module.db.autoSegments = {
	["UNIT_DIED"] = {},
	["SPELL_AURA_APPLIED"] = {},
	["SPELL_AURA_REMOVED"] = {},
	["UNIT_SPELLCAST_SUCCEEDED"] = {},
	["CHAT_MSG_RAID_BOSS_EMOTE"] = {},
}
module.db.segmentsLNames = {
	["UNIT_SPELLCAST_SUCCEEDED"] = ExRT.L.panelBossWatcherSegmentNamesUSS,
	["SPELL_AURA_REMOVED"] = ExRT.L.panelBossWatcherSegmentNamesSAR,
	["SPELL_AURA_APPLIED"] = ExRT.L.panelBossWatcherSegmentNamesSAA,
	["UNIT_DIED"] = ExRT.L.panelBossWatcherSegmentNamesUD,
	['ENCOUNTER_START'] = ExRT.L.panelBossWatcherSegmentNamesES,
	["SLASH"] = ExRT.L.panelBossWatcherSegmentNamesSC,
	["CHAT_MSG_RAID_BOSS_EMOTE"] = ExRT.L.panelBossWatcherSegmentNamesCMRBE,
}
module.db.registerOtherEvents = {}

local function UpdateNewSegmentEvents()
	table_wipe(module.db.autoSegments.UNIT_DIED)
	table_wipe(module.db.autoSegments.SPELL_AURA_APPLIED)
	table_wipe(module.db.autoSegments.SPELL_AURA_REMOVED)
	table_wipe(module.db.autoSegments.UNIT_SPELLCAST_SUCCEEDED)
	table_wipe(module.db.autoSegments.CHAT_MSG_RAID_BOSS_EMOTE)
	table_wipe(module.db.registerOtherEvents)
	for i=1,10 do
		if VExRT.BossWatcher.autoSegments[i] and VExRT.BossWatcher.autoSegments[i][1] and VExRT.BossWatcher.autoSegments[i][2] then
			module.db.autoSegments[ VExRT.BossWatcher.autoSegments[i][2] ][ VExRT.BossWatcher.autoSegments[i][1] ] = true
			if VExRT.BossWatcher.autoSegments[i][2] == 'UNIT_SPELLCAST_SUCCEEDED' then
				module.db.registerOtherEvents['UNIT_SPELLCAST_SUCCEEDED'] = true
			end
			if VExRT.BossWatcher.autoSegments[i][2] == 'CHAT_MSG_RAID_BOSS_EMOTE' then
				module.db.registerOtherEvents['CHAT_MSG_RAID_BOSS_EMOTE'] = true
			end
		end
	end
end

local NewSegment,AddSegmentToData = nil,nil

function module:Enable()
	VExRT.BossWatcher.enabled = true
	
	module:RegisterEvents('ZONE_CHANGED_NEW_AREA')
	module.main:ZONE_CHANGED_NEW_AREA()
	module:RegisterSlash()
	
	UpdateNewSegmentEvents()
end

function module:Disable()
	VExRT.BossWatcher.enabled = nil
	
	module:UnregisterEvents('UNIT_TARGET','ZONE_CHANGED_NEW_AREA','PLAYER_REGEN_DISABLED','PLAYER_REGEN_ENABLED','ENCOUNTER_START','ENCOUNTER_END','UNIT_SPELLCAST_SUCCEEDED')
	module:UnregisterSlash()
end

function module.options:Load()
	local UpdatePage, UpdatePageNewFight
	self.checkEnabled = ExRT.lib.CreateCheckBox(nil,self,nil,20,-7,ExRT.L.panelsenable,VExRT.BossWatcher.enabled)
	self.checkEnabled:SetScript("OnClick", function(self,event) 
		if self:GetChecked() then
			module:Enable()
		else
			module:Disable()
		end
	end)
	
	self.checkShowGUIDs = ExRT.lib.CreateCheckBox(nil,self,nil,200,-7,ExRT.L.panelBossWatcherChkShowGUIDs,VExRT.BossWatcher.GUIDs)
	self.checkShowGUIDs:SetScript("OnClick", function(self,event) 
		if self:GetChecked() then
			VExRT.BossWatcher.GUIDs = true
		else
			VExRT.BossWatcher.GUIDs = nil
		end
		if module.options.targetsList.selected then
			module.options.targetsList:SetListValue(module.options.targetsList.selected)
		end
		UpdatePage()
	end)
	
	local function timestampToFightTime(time)
		if not module.db.timeFix then
			return 0
		end
		local res = time - (module.db.timeFix[2] - module.db.timeFix[1] + module.db.encounterStart) 
		return max(res,0)
	end
	
	self.timeLine = CreateFrame("Frame",nil,self)
	self.timeLine:SetSize(600,30)
	self.timeLine:SetPoint("TOP",0,-50)
	for i=1,20 do
		self.timeLine[i] = CreateFrame("Frame",nil,self.timeLine)
		self.timeLine[i]:SetSize(30,30)
		self.timeLine[i]:SetPoint("TOPLEFT",(i-1)*30,0)
		self.timeLine[i]:SetScript("OnEnter",function (self)
			if self.tooltip and #self.tooltip > 0 then
				ExRT.lib.TooltipShow(self,"ANCHOR_RIGHT",ExRT.L.panelBossWatcherTimeLineTooltipTitle..":",unpack(self.tooltip))
			end
		end)
		self.timeLine[i]:SetScript("OnLeave",function (self)
			ExRT.lib.TooltipHide()	
		end)	
	end
	self.timeLine.texture = self.timeLine:CreateTexture(nil, "BACKGROUND",nil,0)
	self.timeLine.texture:SetTexture("Interface\\AddOns\\ExRT\\media\\bar9.tga",nil)
	self.timeLine.texture:SetVertexColor(0.3, 1, 0.3, 1)
	self.timeLine.texture:SetAllPoints()
	
	self.timeLine.textLeft = ExRT.lib.CreateText(self.timeLine,200,16,nil,0,0,"LEFT","TOP",nil,12,"",nil,1,1,1,1)
	self.timeLine.textLeft:ClearAllPoints()
	self.timeLine.textLeft:SetPoint("BOTTOMLEFT",self.timeLine,"BOTTOMLEFT", 2, 2)

	self.timeLine.textCenter = ExRT.lib.CreateText(self.timeLine,200,16,nil,0,0,"CENTER","TOP",nil,12,"",nil,1,1,1,1)
	self.timeLine.textCenter:ClearAllPoints()
	self.timeLine.textCenter:SetPoint("BOTTOM",self.timeLine,"BOTTOM", 0, 2)

	self.timeLine.textRight = ExRT.lib.CreateText(self.timeLine,200,16,nil,0,0,"RIGHT","TOP",nil,12,"",nil,1,1,1,1)
	self.timeLine.textRight:ClearAllPoints()
	self.timeLine.textRight:SetPoint("BOTTOMRIGHT",self.timeLine,"BOTTOMRIGHT", -2, 2)
	
	self.timeLine.bossName = ExRT.lib.CreateText(self.timeLine,400,16,nil,0,0,"RIGHT","BOTTOM",nil,16,"",nil,1,1,1,1)
	self.timeLine.bossName:ClearAllPoints()
	self.timeLine.bossName:SetPoint("BOTTOMRIGHT",self.timeLine,"TOPRIGHT", 0, 2)
	
	self.timeLine.arrow = self.timeLine:CreateTexture(nil, "BACKGROUND")
	self.timeLine.arrow:SetTexture("Interface\\CURSOR\\Quest",true)
	self.timeLine.arrow:Hide()

	self.timeLine.arrowNow = self.timeLine:CreateTexture(nil, "BACKGROUND")
	self.timeLine.arrowNow:SetTexture("Interface\\CURSOR\\Inspect",true)
	self.timeLine.arrowNow:Hide()
	
	self.timeLine.redLine = {}
	local function CreateRedLine(i)
		module.options.timeLine.redLine[i] = module.options.timeLine:CreateTexture(nil, "BACKGROUND",nil,5)
		module.options.timeLine.redLine[i]:SetTexture(0.7, 0.1, 0.1, 0.5)
		module.options.timeLine.redLine[i]:SetSize(2,30)
	end
	
	self.timeLine.blueLine = {}
	local function CreateBlueLine(i)
		module.options.timeLine.blueLine[i] = module.options.timeLine:CreateTexture(nil, "BACKGROUND",nil,6)
		module.options.timeLine.blueLine[i]:SetTexture(0.1, 0.1, 0.7, 0.5)
		module.options.timeLine.blueLine[i]:SetSize(3,30)
	end
	
	self.tab = ExRT.lib.CreateTabFrame(self:GetName().."Tab",self,600,420,10,-140,4,1,ExRT.L.panelBossWatcherTabMobs,ExRT.L.panelBossWatcherTabInterruptAndDispel,ExRT.L.panelBossWatcherTabBuffsAndDebuffs,ExRT.L.panelBossWatcherSegments)
	
	self.targetsList = ExRT.lib.CreateScrollList(self:GetName().."TargetsList",self.tab.tabs[1],nil,7,-15,280,24)
	
	local function GUIDtoText(patt,GUID)
		if VExRT.BossWatcher.GUIDs and GUID and GUID ~= "" then
			patt = patt or "%s"
			return format(patt,GUID)
		else
			return ""
		end
	end
	
	
	function self.targetsList:SetListValue(index)
		local destGUID = module.options.targetsIndex[index]
		
		local _time = timestampToFightTime(module.db.fightData.damage[module.options.targetsIndex[index]].id)
		local fight_dur = module.db.encounterEnd - module.db.encounterStart
		
		module.options.damgeSwitchTab.text:SetText(module.db.guidsList[destGUID].." "..date("%M:%S", _time )..GUIDtoText(" (%s)",destGUID))
		
		_time = _time / fight_dur
		module.options.timeLine.arrowNow:SetPoint("TOPLEFT",module.options.timeLine,"BOTTOMLEFT",600*_time,0)
		
		module.options.timeLine.arrowNow:Show()

		
		-->
		local damageTable = {}
		local total = 0
		local textResult = ""
		local petBase = {}
		if ExRT.mds.Pets then
			for sourceGUID,sourceDamage in pairs(module.db.fightData.damage[destGUID].d) do
				local owner = ExRT.mds.Pets:getOwnerGUID(sourceGUID)
				if owner then
					petBase[sourceGUID] = owner
				end
			end
		end
		local damageLogCopy = module.db.fightData.damage[destGUID].d
		for petGUID,ownerGUID in pairs(petBase) do
			damageLogCopy[ownerGUID] = damageLogCopy[ownerGUID] and damageLogCopy[ownerGUID] + damageLogCopy[petGUID] or damageLogCopy[petGUID]
			damageLogCopy[petGUID] = nil
		end
		for sourceGUID,sourceDamage in pairs(damageLogCopy) do
			table.insert(damageTable,{module.db.guidsList[sourceGUID],sourceDamage,sourceGUID})
			total = total + sourceDamage
		end
		table.sort(damageTable,function(a,b) return a[2] > b[2] end)
		textResult = ExRT.L.panelBossWatcherReportTotal..": " .. ExRT.mds.shortNumber(total) .. "\n\n"
		for i=1,#damageTable do
			textResult = textResult .. damageTable[i][1] .. GUIDtoText(" <%s>",damageTable[i][3]) .. " " .. ExRT.mds.shortNumber(damageTable[i][2]) .. " " .. format("%.1f%%",damageTable[i][2]/total*100) .. "\n"
		end
		module.options.damgeBox.EditBox:SetText(textResult)
		
		-->
		textResult = ""
		if module.db.fightData.switch[destGUID] then
			local switchTable = {}

			for sourceGUID,sourceTime in pairs(module.db.fightData.switch[destGUID][1]) do
				table.insert(switchTable,{module.db.guidsList[sourceGUID],timestampToFightTime(sourceTime),sourceGUID})
			end
			table.sort(switchTable,function(a,b) return a[2] < b[2] end)
			if #switchTable > 0 then
				textResult = ExRT.L.panelBossWatcherReportCast.." [" .. date("%M:%S", switchTable[1][2] ) .."]: "
				for i=1,#switchTable do
					textResult = textResult .. switchTable[i][1] .. GUIDtoText(" <%s>",switchTable[i][3]) .. " (".. format("%.3f",switchTable[i][2]-switchTable[1][2])..")"
					if i ~= #switchTable then
						textResult = textResult .. ", "
					end
				end
				textResult = textResult .. "\n\n"
			end
			
			table_wipe(switchTable)
			for sourceGUID,sourceTime in pairs(module.db.fightData.switch[destGUID][2]) do
				table.insert(switchTable,{module.db.guidsList[sourceGUID],sourceTime - module.db.encounterStart,sourceGUID})
			end
			table.sort(switchTable,function(a,b) return a[2] < b[2] end)
			if #switchTable > 0 then
				textResult = textResult .. ExRT.L.panelBossWatcherReportSwitch.." [" .. date("%M:%S", switchTable[1][2] ) .."]: "
				for i=1,#switchTable do
					textResult = textResult .. switchTable[i][1] .. GUIDtoText(" <%s>",switchTable[i][3]) .. " (".. format("%.3f",switchTable[i][2]-switchTable[1][2])..")"
					if i ~= #switchTable then
						textResult = textResult .. ", "
					end
				end
			end
		end		
		module.options.switchBox.EditBox:SetText(textResult)
		
		--> Other Info
		textResult = ExRT.L.panelBossWatcherDamageSwitchTabInfoNoInfo
		for i=1,#module.db.fightData.dies do
			if module.db.fightData.dies[i][1]==destGUID then
				textResult = ExRT.L.panelBossWatcherDamageSwitchTabInfoRIP..": ".. date("%M:%S", timestampToFightTime(module.db.fightData.dies[i][3]) ) .. date(" (%H:%M:%S)", module.db.fightData.dies[i][3] )
				break
			end
		end
		module.options.infoBoxText:SetText(textResult)
	end
	
	function self.targetsList:HoverListValue(isHover,index)
		if not isHover then
			module.options.timeLine.arrow:Hide()
			if VExRT.BossWatcher.GUIDs then
				GameTooltip_Hide()
			end
		else
			local _time = timestampToFightTime( module.db.fightData.damage[module.options.targetsIndex[index]].id )
			local fight_dur = module.db.encounterEnd - module.db.encounterStart
			
			_time = _time / fight_dur
			module.options.timeLine.arrow:SetPoint("TOPLEFT",module.options.timeLine,"BOTTOMLEFT",600*_time,0)
			
			module.options.timeLine.arrow:Show()
			
			if VExRT.BossWatcher.GUIDs then
				GameTooltip:SetOwner(self,"ANCHOR_CURSOR")
				GameTooltip:SetText(module.options.targetsIndex[index] or "")
				GameTooltip:Show()
			end
		end
	end
	
	self.targetsList.dataIndex = nil
	self.targetsIndex = {}
	
	self.damgeSwitchTab = ExRT.lib.CreateTabFrame(self:GetName().."DamgeSwitchTab",self.tab.tabs[1],300,350,290,-35,3,1,ExRT.L.panelBossWatcherDamageSwitchTabDamage,ExRT.L.panelBossWatcherDamageSwitchTabSwitch,ExRT.L.panelBossWatcherDamageSwitchTabInfo)
	self.damgeSwitchTab.text = ExRT.lib.CreateText(self.damgeSwitchTab,280,12,"TOP",0,-8,"LEFT","TOP",nil,11,"",nil,1,1,1)
	self.damgeSwitchTab.textFrame = ExRT.lib.CreateHiddenFrame(nil,self.damgeSwitchTab,"TOP",0,-8,280,12)
	self.damgeSwitchTab.textFrame:SetScript("OnEnter",function (self)
		ExRT.lib.TooltipShow(self,"ANCHOR_LEFT",module.options.damgeSwitchTab.text:GetText())
	end)
	self.damgeSwitchTab.textFrame:SetScript("OnLeave",function ()
		ExRT.lib.TooltipHide()
	end)
		
	self.damgeBox = ExRT.lib.CreateMultiEditBox(self:GetName().."DamgeBox",self.damgeSwitchTab.tabs[1],275,310,"TOP",0,-25)
	self.switchBox = ExRT.lib.CreateMultiEditBox(self:GetName().."SwitchBox",self.damgeSwitchTab.tabs[2],275,310,"TOP",0,-25)
	self.infoBoxText = ExRT.lib.CreateText(self.damgeSwitchTab.tabs[3],275,310,"TOP",0,-25,"LEFT","TOP",nil,12,ExRT.L.panelBossWatcherDamageSwitchTabInfoNoInfo,nil,1,1,1)
	
	self.buttonToChat = ExRT.lib.CreateButton(nil,self.tab.tabs[1],300,22,nil,290,-385,ExRT.L.panelBossWatcherToChat)
	self.buttonToChat:SetScript("OnClick",function ()
		local textResult = ""
		if self.damgeSwitchTab.selected == 1 then
			textResult = self.damgeBox.EditBox:GetText()
		elseif self.damgeSwitchTab.selected == 2 then
			textResult = self.switchBox.EditBox:GetText()
		end
		local strings = {strsplit("\n", textResult)}
		local chat_type = ExRT.mds.chatType(true)
		if #strings > 1 then
			SendChatMessage(self.damgeSwitchTab.text:GetText(),chat_type)
		end
		for i=1,#strings do
			--print(i,strings[i])
			if strings[i] ~= "" then
				SendChatMessage(strings[i],chat_type)
			end
		end
	end)
	
	self.interruptBox = ExRT.lib.CreateMultiEditBox(self:GetName().."InterruptBox",self.tab.tabs[2],570,180,"TOP",0,-25)
	self.interruptBox.text = ExRT.lib.CreateText(self.tab.tabs[2],560,12,"TOP",0,-8,"LEFT","TOP",nil,12,ExRT.L.panelBossWatcherInterrupts,nil,1,1,1)

	self.dispelBox = ExRT.lib.CreateMultiEditBox(self:GetName().."DispelBox",self.tab.tabs[2],570,180,"TOP",0,-230)
	self.dispelBox.text = ExRT.lib.CreateText(self.tab.tabs[2],560,12,"TOP",0,-213,"LEFT","TOP",nil,12,ExRT.L.panelBossWatcherDispels,nil,1,1,1)
	
	self.buffs = {}
	self.buffs.timeLine = {}
	
	for i=1,10 do
		self.buffs.timeLine[i] = CreateFrame("Frame",nil,self.tab.tabs[3])
		self.buffs.timeLine[i]:SetPoint("TOPLEFT",100+(i-1)*47,-42)
		self.buffs.timeLine[i]:SetSize(2,374)
		
		self.buffs.timeLine[i].texture = self.buffs.timeLine[i]:CreateTexture(nil, "BACKGROUND")
		self.buffs.timeLine[i].texture:SetTexture(1, 1, 1, 0.3)
		self.buffs.timeLine[i].texture:SetAllPoints()		
		
		self.buffs.timeLine[i].timeText = ExRT.lib.CreateText(self.buffs.timeLine[i],200,12,"TOPLEFT",4,-2,"LEFT","TOP",nil,11,"0:00",nil,1,1,1)
	
	end
	
	self.buffs.lines = {}
	for i=1,20 do
		self.buffs.lines[i] = CreateFrame("Frame",nil,self.tab.tabs[3])
		self.buffs.lines[i]:SetSize(575,18)
		self.buffs.lines[i]:SetPoint("TOPLEFT", 5, -18*(i-1)-54)
		
		self.buffs.lines[i].spellIcon = self.buffs.lines[i]:CreateTexture(nil, "BACKGROUND")
		self.buffs.lines[i].spellIcon:SetSize(16,16)
		self.buffs.lines[i].spellIcon:SetPoint("TOPLEFT", 3, -1)
		--self.buffs.lines[i].spellIcon:SetTexture(GetSpellTexture(105809))
		
		self.buffs.lines[i].spellText = ExRT.lib.CreateText(self.buffs.lines[i],79,18,"TOPLEFT",20,0,"LEFT","MIDDLE",nil,11,"",nil,1,1,1)
		
		self.buffs.lines[i].green = {}
		self.buffs.lines[i].greenFrame = {}
		--self.buffs.lines[i].greenTooltipFrame = {}
		self.buffs.lines[i].greenCount = 0
		
		self.buffs.lines[i].greenTooltips = {}
		
		ExRT.lib.CreateHoverHighlight(self.buffs.lines[i])
		self.buffs.lines[i].hl:SetAlpha(.5)
		
		self.buffs.lines[i]:SetScript("OnUpdate",function(self)
			local x_f,y_f = GetCursorPosition()
			local s = self:GetEffectiveScale()
			x_f, y_f = x_f/s, y_f/s
			local x,y = self:GetLeft(),self:GetTop()
			x = x_f-x
			y = (y_f-y)*(-1)
			if x > 0 and x < 575 and y > 0 and y < 18 and not module.options.buffs.filterFrame:IsShown() then
				self.hl:Show()
				if x <= 100 then
					GameTooltip:SetOwner(self, "ANCHOR_LEFT")
					GameTooltip:SetHyperlink(self.spellLink)
					
					local uptime = 0
					local minLimit = 0
					local maxLimit = 0
					for j = 1,#self.greenTooltips do
						maxLimit = max(maxLimit,self.greenTooltips[j][2])
					end
					while true do
						local _min,_max = 570,100
						local bool = true
						for j = 1,#self.greenTooltips do
							if self.greenTooltips[j][1] < _min and self.greenTooltips[j][1] > minLimit then
								_min = min(_min,self.greenTooltips[j][1])
							end
						end
						for j = 1,#self.greenTooltips do
							if self.greenTooltips[j][1] <= _min then
								_max = max(_max,self.greenTooltips[j][2])
							end	
						end
						while bool == true do
							bool = false
							for j = 1,#self.greenTooltips do
								if self.greenTooltips[j][1] <= _max and _max < self.greenTooltips[j][2] then
									_max = max(_max,self.greenTooltips[j][2])
									bool = true
								end	
							end
						end
						uptime = uptime + (_max - _min)/470
						minLimit = _max
						if _max == maxLimit or _max <= 100 then
							break
						end
					end
					
					GameTooltip:AddLine(ExRT.L.panelBossWatcherBuffsAndDebuffsTooltipUptimeText..": "..format("%.2f%%",uptime*100))
					GameTooltip:AddLine(ExRT.L.panelBossWatcherBuffsAndDebuffsTooltipCountText..": "..(self.greenCount or 0))
					GameTooltip:Show()
				else
					if not self.tooltip then
						self.tooltip = {}
					end
					table.wipe(self.tooltip)
					local owner = nil
					for j = 1,#self.greenTooltips do
						local rightPos = self.greenTooltips[j][2]
						local leftPos = self.greenTooltips[j][1]
						if rightPos - leftPos < 2 then
							rightPos = leftPos + 2
						end
						if x >= leftPos and x <= rightPos then
							local sourceClass,destClass = self.greenTooltips[j][5],self.greenTooltips[j][6]
							if sourceClass and sourceClass ~= 0 and sourceClass ~= "" then
								sourceClass = select(2,GetPlayerInfoByGUID(sourceClass))
							end
							if destClass and destClass ~= 0 and destClass ~= "" then
								destClass = select(2,GetPlayerInfoByGUID(destClass))
							end
							sourceClass = ExRT.mds.classColor(sourceClass or '?')
							destClass = ExRT.mds.classColor(destClass or '?')
							local duration = (self.greenTooltips[j][4] - self.greenTooltips[j][3])
							table.insert(self.tooltip, date("[%M:%S", self.greenTooltips[j][3] ) .. format(".%03d",(self.greenTooltips[j][3]*1000)%1000).. "] " .. "|c" .. sourceClass .. (module.db.guidsList[self.greenTooltips[j][5]] or "Unknown")..GUIDtoText("(%s)",self.greenTooltips[j][5]).."|r "..ExRT.L.panelBossWatcherBuffsAndDebuffsTextOn.." |c".. destClass .. (module.db.guidsList[self.greenTooltips[j][6]] or "Unknown")..GUIDtoText("(%s)",self.greenTooltips[j][6]).."|r")
							if self.greenTooltips[j][7] and self.greenTooltips[j][7] ~= 1 then
								self.tooltip[#self.tooltip] = self.tooltip[#self.tooltip] .. " (".. self.greenTooltips[j][7] ..")"
							end
							self.tooltip[#self.tooltip] = self.tooltip[#self.tooltip] .. format(" <%.1fs>",duration)
							owner = self.greenTooltips[j][1]
						end
					end
					if #self.tooltip > 0 then
						table.sort(self.tooltip,function(a,b) return a < b end)
						ExRT.lib.TooltipShow(self,{"ANCHOR_LEFT",owner or 0,0},ExRT.L.panelBossWatcherBuffsAndDebuffsTooltipTitle..":",unpack(self.tooltip))
					else
						GameTooltip_Hide()
					end
				end
			end
		end) 
		self.buffs.lines[i]:SetScript("OnLeave",function ()
			GameTooltip_Hide()
			self.buffs.lines[i].hl:Hide()
		end)
	end
	
	self.buffs.scrollBar = ExRT.lib.CreateScrollBar2(self:GetName().."BuffsScrollBar",self.tab.tabs[3],16,360,-4,-54,1,2,"TOPRIGHT")
	
	local function CreateBuffGreen(i,j)
		module.options.buffs.lines[i].green[j] = module.options.buffs.lines[i]:CreateTexture(nil, "BACKGROUND",nil,5)
		module.options.buffs.lines[i].green[j]:SetTexture(0.1, 0.7, 0.1, 0.7)
		module.options.buffs.lines[i].greenFrame[j] = CreateFrame("Frame",nil,module.options.buffs.lines[i])
	end
	
	local function CreateFilterText()
		local result = ExRT.L.panelBossWatcherBuffsAndDebuffsFilterSource..": "
		if not module.options.buffs.filterS then
			result = result .. ExRT.L.panelBossWatcherBuffsAndDebuffsFilterAll
		elseif module.options.buffs.filterS == 1 then
			result = result .. ExRT.L.panelBossWatcherBuffsAndDebuffsFilterFriendly
		elseif module.options.buffs.filterS == 2 then
			result = result .. ExRT.L.panelBossWatcherBuffsAndDebuffsFilterHostile
		else 
			result = result .. (module.db.guidsList[module.options.buffs.filterS] or "Unknown")
		end
		result = result .. "; "..ExRT.L.panelBossWatcherBuffsAndDebuffsFilterTarget..": "
		if not module.options.buffs.filterD then
			result = result .. ExRT.L.panelBossWatcherBuffsAndDebuffsFilterAll
		elseif module.options.buffs.filterD == 1 then
			result = result .. ExRT.L.panelBossWatcherBuffsAndDebuffsFilterFriendly
		elseif module.options.buffs.filterD == 2 then
			result = result .. ExRT.L.panelBossWatcherBuffsAndDebuffsFilterHostile
		else 
			result = result .. (module.db.guidsList[module.options.buffs.filterD] or "Unknown")
		end			
		result = result .. ";"
		
		local isSpecial = nil
		for i=1,#module.db.buffsFilters do
			if module.db.buffsFilterStatus[i] then
				isSpecial = true
				break
			end
		end
		if isSpecial then
			result = result .. " "..ExRT.L.panelBossWatcherBuffsAndDebuffsFilterSpecial..":"
			for i=1,#module.db.buffsFilters do
				if module.db.buffsFilterStatus[i] then
					result = result .. " " .. strlower(module.db.buffsFilters[i][-1]) .. ";"
				end
			end
		end
		module.options.buffs.filterText:SetText(result)
	end
	
	local function UpdateBuffPageDB()
		for i=1,10 do
			self.buffs.timeLine[i].timeText:SetText( date("%M:%S", (module.db.encounterEnd - module.db.encounterStart)*((i-1)/10) ) )
		end
		
		if not module.db.fightData.buffs then
			module.db.fightData.buffs = {}
		end
		
		local fightDuration = (module.db.encounterEnd - module.db.encounterStart)
		local buffTable = {}
		for i=1,#module.db.fightData.buffs do 
			local sourceData = module.db.fightData.buffs[i]
			local spellID = sourceData[6]
			if (not module.options.buffs.filterS or (module.options.buffs.filterS == 1 and sourceData[4]) or (module.options.buffs.filterS == 2 and not sourceData[4]) or module.options.buffs.filterS == sourceData[2]) and 
				(not module.options.buffs.filterD or (module.options.buffs.filterD == 1 and sourceData[5]) or (module.options.buffs.filterD == 2 and not sourceData[5]) or module.options.buffs.filterD == sourceData[3]) and 
				(not module.db.buffsFilterStatus[1] or module.db.buffsFilters[1][spellID]) and 
				(not module.db.buffsFilterStatus[2] or sourceData[7] == 'BUFF') and
				(not module.db.buffsFilterStatus[3] or sourceData[7] == 'DEBUFF') and
				(not module.db.buffsFilterStatus[4] or module.db.buffsFilters[4][spellID]) and
				(not module.db.buffsFilterStatus[5] or not module.db.buffsFilters[5][spellID]) and
				(not module.db.buffsFilterStatus[6] or module.db.buffsFilters[6][spellID]) and
				(not module.db.buffsFilterStatus[7] or module.db.buffsFilters[7][spellID]) then
				
				local spellName,_,spellTexture = GetSpellInfo(spellID)
				local time_ = timestampToFightTime( sourceData[1] )
				local time_postion = time_ / fightDuration
				local type_ = sourceData[8]
				
				local buffTablePos
				for j=1,#buffTable do
					if buffTable[j][1] == spellID then
						buffTablePos = j
						break
					end
				end
				if not buffTablePos then
					buffTablePos = #buffTable + 1
					buffTable[buffTablePos] = {spellID,spellName,spellTexture,{},{}}
				end
				
				local sourceGUID = sourceData[2] or 0
				local destGUID = sourceData[3] or 0
				local sourceDest = sourceGUID .. destGUID
				local buffTableBuffPos
				for j=1,#buffTable[buffTablePos][4] do
					if buffTable[buffTablePos][4][j][1] == sourceDest then
						buffTableBuffPos = j
						break
					end
				end
				if not buffTableBuffPos then
					buffTableBuffPos = #buffTable[buffTablePos][4] + 1
					buffTable[buffTablePos][4][buffTableBuffPos] = {sourceDest,sourceGUID,destGUID,{}}
				end
				
				local eventPos = #buffTable[buffTablePos][4][buffTableBuffPos][4] + 1
				
				if type_ == 3 or type_ == 4 then
					buffTable[buffTablePos][4][buffTableBuffPos][4][eventPos] = {0,time_,time_postion,sourceData[9] or 1}
					type_ = 1
					eventPos = eventPos + 1
				end
				buffTable[buffTablePos][4][buffTableBuffPos][4][eventPos] = {type_ % 2,time_,time_postion,sourceData[9] or 1}
			end
		end
		
		table.sort(buffTable,function(a,b) return a[2] < b[2] end)
		
		for i=1,#buffTable do 
			for j=1,#buffTable[i][4] do
				local maxEvents = #buffTable[i][4][j][4]
				if maxEvents > 0 and buffTable[i][4][j][4][1][1] == 0 then
					local newLine = #buffTable[i][5] + 1
					buffTable[i][5][newLine] = {
						100,
						100+470*buffTable[i][4][j][4][1][3],
						0,
						buffTable[i][4][j][4][1][2],
						buffTable[i][4][j][2],
						buffTable[i][4][j][3],
						1,
					}
				end
				for k=1,maxEvents do
					if buffTable[i][4][j][4][k][1] == 1 then
						local endOfTime = nil
						for n=(k+1),maxEvents do
							if buffTable[i][4][j][4][n][1] == 0 and not endOfTime then
								endOfTime = n
								--break
							end
						end
						local newLine = #buffTable[i][5] + 1
						buffTable[i][5][newLine] = {
							100+470*buffTable[i][4][j][4][k][3],
							100+470*(endOfTime and buffTable[i][4][j][4][endOfTime][3] or 1),
							buffTable[i][4][j][4][k][2],
							endOfTime and buffTable[i][4][j][4][endOfTime][2] or fightDuration,
							buffTable[i][4][j][2],
							buffTable[i][4][j][3],
							buffTable[i][4][j][4][k][4],
						}
						--startPos,endPos,startTime,endTime,sourceGUID,destGUID,stacks
					end
				end
			end
		end
		
		module.options.buffs.scrollBar:SetValue(1)
		module.options.buffs.scrollBar:SetMinMaxValues(1,max(#buffTable-20,1))
		if module.options.buffs.db then
			table_wipe(module.options.buffs.db)
		end
		
		module.options.buffs.db = buffTable
	end
	
	local function UpdateBuffsPage()
		CreateFilterText()
		if not module.options.buffs.db then
			return
		end
		
		local minVal = ExRT.mds.Round(module.options.buffs.scrollBar:GetValue())
		local buffTable2 = module.options.buffs.db
		
		local linesCount = 0
		for i=1,20 do
			for j=1,module.options.buffs.lines[i].greenCount do
				module.options.buffs.lines[i].green[j]:Hide()
			end
			module.options.buffs.lines[i].greenCount = 0
			table.wipe(module.options.buffs.lines[i].greenTooltips)
		end
		for i=minVal,#buffTable2 do
			linesCount = linesCount + 1
			local Line = module.options.buffs.lines[linesCount]
			Line.spellIcon:SetTexture(buffTable2[i][3])
			Line.spellText:SetText(buffTable2[i][2] or "???")
			Line.spellLink = GetSpellLink(buffTable2[i][1])
			
			for j=1,#buffTable2[i][5] do
				Line.greenCount = Line.greenCount + 1
				local n = Line.greenCount

				if not Line.green[n] then
					CreateBuffGreen(linesCount,n)
				end
				
				Line.green[n]:SetPoint("TOPLEFT",buffTable2[i][5][j][1],0)
				Line.green[n]:SetSize(max(buffTable2[i][5][j][2]-buffTable2[i][5][j][1],0.1),18)
				Line.green[n]:Show()
				
				Line.greenTooltips[#Line.greenTooltips+1] = buffTable2[i][5][j]
			end

			Line:Show()
			if linesCount >= 20 then
				break
			end
		end
		for i=(linesCount+1),20 do
			module.options.buffs.lines[i]:Hide()
		end
	end
	
	self.tab.tabs[3]:SetScript("OnShow",function (self)
		if self.lastFightID ~= module.db.lastFightID then
			UpdateBuffPageDB()
			self.lastFightID = module.db.lastFightID
		end
		UpdateBuffsPage()
	end)

	self.buffs.scrollBar:SetScript("OnValueChanged",UpdateBuffsPage)
	self.tab.tabs[3]:SetScript("OnMouseWheel",function (self,delta)
		if delta > 0 then
			module.options.buffs.scrollBar.buttonUP:Click("LeftButton")
		else
			module.options.buffs.scrollBar.buttonDown:Click("LeftButton")
		end
	end)

	self.buffs.filterFrame = ExRT.lib.CreatePopupFrame(self:GetName().."BuffsFilterFrame",550,400,ExRT.L.panelBossWatcherBuffsAndDebuffsFilterFilter)
	
	local function UpdateTargetsList(self,isSourceFrame,friendly,hostile)
		table.wipe(self.L)
		table.wipe(self.LGUID)
		if isSourceFrame then
			isSourceFrame = 4
		else
			isSourceFrame = 5
		end
		local list = {}
		for i=1,#module.db.fightData.buffs do
			local sourceData = module.db.fightData.buffs[i]
			local sourceGUID = (friendly and sourceData[isSourceFrame] and sourceData[2]) or (hostile and not sourceData[isSourceFrame] and sourceData[3])
			if sourceGUID then
				local inList = nil
				for j=1,#list do
					if list[j][1] == sourceGUID then
						inList = true
						break
					end
				end
				if not inList then
					list[#list+1] = {sourceGUID,module.db.guidsList[sourceGUID] or "Unknown"}
				end
			end
		end

		table.sort(list,function(a,b) return a[2] < b[2] end)
		
		for i=1,#list do
			self.L[i] = list[i][2]
			self.LGUID[i] = list[i][1]
		end
		table.sort(self.L)
		self.Update()
	end
	
	self.buffs.filterFrame:SetScript("OnShow",function()
		UpdateTargetsList(self.buffs.filterFrame.sourceScroll,true,self.buffs.filterFrame.sourceFriendly:GetChecked(),self.buffs.filterFrame.sourceHostile:GetChecked())
		UpdateTargetsList(self.buffs.filterFrame.targetScroll,nil,self.buffs.filterFrame.targetFriendly:GetChecked(),self.buffs.filterFrame.targetHostile:GetChecked())
	end)
	
	self.buffs.filterFrame.sourceScroll = ExRT.lib.CreateScrollList(self:GetName().."BuffsFilterFrameSourceScroll",self.buffs.filterFrame,nil,10,-62,190,17)
	self.buffs.filterFrame.sourceScroll.LGUID = {}
	self.buffs.filterFrame.sourceScroll.dontDisable = true
	
	self.buffs.filterFrame.sourceClear = ExRT.lib.CreateButton(nil,self.buffs.filterFrame,190,16,nil,10,-30,ExRT.L.panelBossWatcherBuffsAndDebuffsFilterClear)
	self.buffs.filterFrame.sourceClear:SetScript("OnClick",function ()
		module.options.buffs.filterS = nil
		module.options.buffs.filterFrame.sourceFriendly:SetChecked(true)
		module.options.buffs.filterFrame.sourceFriendly:SetChecked(true)
		UpdateTargetsList(module.options.buffs.filterFrame.sourceScroll,true,module.options.buffs.filterFrame.sourceFriendly:GetChecked(),module.options.buffs.filterFrame.sourceHostile:GetChecked())
		module.options.buffs.filterFrame.sourceText:SetText(ExRT.L.panelBossWatcherBuffsAndDebuffsFilterNone)
		UpdateBuffPageDB()
		UpdateBuffsPage()
	end)
	self.buffs.filterFrame.sourceText = ExRT.lib.CreateText(self.buffs.filterFrame,180,16,nil,15,-46,"LEFT","MIDDLE",nil,11,ExRT.L.panelBossWatcherBuffsAndDebuffsFilterNone,nil,1,1,1)
	
	self.buffs.filterFrame.sourceFriendly = ExRT.lib.CreateCheckBox(self:GetName().."BuffsFilterFrameSourceCheckFriendly",self.buffs.filterFrame,nil,10,-338,ExRT.L.panelBossWatcherBuffsAndDebuffsFilterFriendly,true)
	self.buffs.filterFrame.sourceHostile = ExRT.lib.CreateCheckBox(self:GetName().."BuffsFilterFrameSourceCheckHostile",self.buffs.filterFrame,nil,10,-363,ExRT.L.panelBossWatcherBuffsAndDebuffsFilterHostile,true)
	self.buffs.filterFrame.sourceFriendly:SetScript("OnClick",function ()
		UpdateTargetsList(self.buffs.filterFrame.sourceScroll,true,self.buffs.filterFrame.sourceFriendly:GetChecked(),self.buffs.filterFrame.sourceHostile:GetChecked())
		if self.buffs.filterFrame.sourceFriendly:GetChecked() then
			module.options.buffs.filterS = 1
		end
		if self.buffs.filterFrame.sourceHostile:GetChecked() then
			if module.options.buffs.filterS == 1 then
				module.options.buffs.filterS = nil
			else
				module.options.buffs.filterS = 2
			end
		end
		UpdateBuffPageDB()
		UpdateBuffsPage()
	end)
	self.buffs.filterFrame.sourceHostile:SetScript("OnClick",self.buffs.filterFrame.sourceFriendly:GetScript("OnClick"))
	
	function self.buffs.filterFrame.sourceScroll:SetListValue(index)
		module.options.buffs.filterS = module.options.buffs.filterFrame.sourceScroll.LGUID[index]
		module.options.buffs.filterFrame.sourceText:SetText(module.options.buffs.filterFrame.sourceScroll.L[index])
		UpdateBuffPageDB()
		UpdateBuffsPage()
	end
	
	function self.buffs.filterFrame.sourceScroll:HoverListValue(isHover,index)
		if VExRT.BossWatcher.GUIDs then
			if not isHover then
				GameTooltip_Hide()
			else
				GameTooltip:SetOwner(self,"ANCHOR_CURSOR")
				GameTooltip:SetText(module.options.buffs.filterFrame.sourceScroll.LGUID[index] or "")
				GameTooltip:Show()
			end
		end
	end

	self.buffs.filterFrame.targetScroll = ExRT.lib.CreateScrollList(self:GetName().."BuffsFilterFrameTargetScroll",self.buffs.filterFrame,nil,210,-62,190,17)
	self.buffs.filterFrame.targetScroll.LGUID = {}
	self.buffs.filterFrame.targetScroll.dontDisable = true
	
	self.buffs.filterFrame.targetClear = ExRT.lib.CreateButton(nil,self.buffs.filterFrame,190,16,nil,210,-30,ExRT.L.panelBossWatcherBuffsAndDebuffsFilterClear)
	self.buffs.filterFrame.targetClear:SetScript("OnClick",function ()
		module.options.buffs.filterD = nil
		module.options.buffs.filterFrame.targetFriendly:SetChecked(true)
		module.options.buffs.filterFrame.targetFriendly:SetChecked(true)
		UpdateTargetsList(module.options.buffs.filterFrame.targetScroll,nil,module.options.buffs.filterFrame.targetFriendly:GetChecked(),module.options.buffs.filterFrame.targetHostile:GetChecked())
		module.options.buffs.filterFrame.targetText:SetText(ExRT.L.panelBossWatcherBuffsAndDebuffsFilterNone)
		UpdateBuffPageDB()
		UpdateBuffsPage()
	end)
	self.buffs.filterFrame.targetText = ExRT.lib.CreateText(self.buffs.filterFrame,180,16,nil,215,-46,"LEFT","MIDDLE",nil,11,ExRT.L.panelBossWatcherBuffsAndDebuffsFilterNone,nil,1,1,1)

	self.buffs.filterFrame.targetFriendly = ExRT.lib.CreateCheckBox(self:GetName().."BuffsFilterFrameTargetCheckFriendly",self.buffs.filterFrame,nil,210,-338,ExRT.L.panelBossWatcherBuffsAndDebuffsFilterFriendly,true)
	self.buffs.filterFrame.targetHostile = ExRT.lib.CreateCheckBox(self:GetName().."BuffsFilterFrameTargetCheckHostile",self.buffs.filterFrame,nil,210,-363,ExRT.L.panelBossWatcherBuffsAndDebuffsFilterHostile,true)
	self.buffs.filterFrame.targetFriendly:SetScript("OnClick",function ()
		UpdateTargetsList(self.buffs.filterFrame.targetScroll,nil,self.buffs.filterFrame.targetFriendly:GetChecked(),self.buffs.filterFrame.targetHostile:GetChecked())
		if self.buffs.filterFrame.targetFriendly:GetChecked() then
			module.options.buffs.filterD = 1
		end
		if self.buffs.filterFrame.targetHostile:GetChecked() then
			if module.options.buffs.filterD == 1 then
				module.options.buffs.filterD = nil
			else
				module.options.buffs.filterD = 2
			end
		end
		UpdateBuffPageDB()
		UpdateBuffsPage()
	end)
	self.buffs.filterFrame.targetHostile:SetScript("OnClick",self.buffs.filterFrame.targetFriendly:GetScript("OnClick"))

	function self.buffs.filterFrame.targetScroll:SetListValue(index)
		module.options.buffs.filterD = module.options.buffs.filterFrame.targetScroll.LGUID[index]
		module.options.buffs.filterFrame.targetText:SetText(module.options.buffs.filterFrame.targetScroll.L[index])
		UpdateBuffPageDB()
		UpdateBuffsPage()
	end
	
	function self.buffs.filterFrame.targetScroll:HoverListValue(isHover,index)
		if VExRT.BossWatcher.GUIDs then
			if not isHover then
				GameTooltip_Hide()
			else
				GameTooltip:SetOwner(self,"ANCHOR_CURSOR")
				GameTooltip:SetText(module.options.buffs.filterFrame.targetScroll.LGUID[index] or "")
				GameTooltip:Show()
			end
		end
	end
	
	self.buffs.filterFrame.chkSpecial = {}
	for i=1,#module.db.buffsFilters do
		self.buffs.filterFrame.chkSpecial[i] = ExRT.lib.CreateCheckBox(nil,self.buffs.filterFrame,nil,405,-35-(i-1)*25,module.db.buffsFilters[i][-1])
		self.buffs.filterFrame.chkSpecial[i]:SetScript("OnClick",function (this)
			if this:GetChecked() then
				module.db.buffsFilterStatus[i] = true
			else
				module.db.buffsFilterStatus[i] = nil
			end
			UpdateBuffPageDB()
			UpdateBuffsPage()
		end)
		self.buffs.filterFrame.chkSpecial[i].hover = CreateFrame("Frame",nil,self.buffs.filterFrame)
		self.buffs.filterFrame.chkSpecial[i].hover:SetPoint("TOPLEFT",430,-35-(i-1)*25)
		self.buffs.filterFrame.chkSpecial[i].hover:SetSize(110,25)
		self.buffs.filterFrame.chkSpecial[i].hover:SetScript("OnEnter",function (self)
			local sList = {}
			for sid,_ in pairs(module.db.buffsFilters[i]) do
				if sid ~= -1 then
					table.insert(sList,sid)
				end
			end
			if #sList > 0 then
				local sList2 = {}
				for j=1,#sList do
					local sID,_,sT=GetSpellInfo(sList[j])
					if sID then
						table.insert(sList2,"|T"..sT..":0|t |cffffffff"..sID.."|r")
					end
				end
				ExRT.lib.TooltipShow(self,"ANCHOR_LEFT",ExRT.L.panelBossWatcherFilterTooltip..":",unpack(sList2))
			end
		end)
		self.buffs.filterFrame.chkSpecial[i].hover:SetScript("OnLeave",function ()
		  	GameTooltip_Hide()
		end)		
	end
	self.buffs.filterFrame.chkSpecial[4].ebox = ExRT.lib.CreateEditBox(self:GetName().."BuffsFilterFrameCheckSpecial4eBox",self.buffs.filterFrame.chkSpecial[4],55,24,nil,78,-2,nil,6,true,"InputBoxTemplate","0")
	self.buffs.filterFrame.chkSpecial[4].ebox:SetScript("OnTextChanged",function (self)
		local t = tonumber(self:GetText() or 0)
		if t then
			module.db.buffsFilters[4][t] = true
			if module.options.buffs.filterFrame.chkSpecial[4]:GetChecked() then
				UpdateBuffPageDB()
				UpdateBuffsPage()
			end
		end
	end)
	
	self.buffs.filterButton = ExRT.lib.CreateButton(nil,self.tab.tabs[3],100,22,nil,5,-10,ExRT.L.panelBossWatcherBuffsAndDebuffsFilterFilter)
	self.buffs.filterButton:SetScript("OnClick",function ()
		module.options.buffs.filterFrame:Show()
	end)
	
	self.buffs.filterText = ExRT.lib.CreateText(self.tab.tabs[3],500,22,nil,110,-10,"LEFT","CENTER",nil,nil,"",nil,1,1,1,1)
	CreateFilterText()
	
	

	
	self.buffs.timeSegments = {}
	self.timeLine.timeSegments = {}
	local function CreateBuffSegmentBack(i)
		if not self.buffs.timeSegments[i] then
		  	self.buffs.timeSegments[i] = CreateFrame("Frame",nil,self.tab.tabs[3])
			
			self.buffs.timeSegments[i].texture = self.buffs.timeSegments[i]:CreateTexture(nil, "BACKGROUND",0,-5)
			self.buffs.timeSegments[i].texture:SetTexture(1, 1, 0.5, 0.2)
			self.buffs.timeSegments[i].texture:SetAllPoints()
		end
		if not self.timeLine.timeSegments[i] then
			self.timeLine.timeSegments[i] = self.timeLine:CreateTexture(nil, "BACKGROUND",nil,1)
			self.timeLine.timeSegments[i]:SetTexture("Interface\\AddOns\\ExRT\\media\\bar9.tga",nil)
			self.timeLine.timeSegments[i]:SetVertexColor(0.8, 0.8, 0.8, 1)
		end
	end
	
	self.segmentsText = ExRT.lib.CreateText(self.tab.tabs[4],180,15,nil,17,-10,"LEFT",nil,nil,11,ExRT.L.panelBossWatcherSegments..":",nil,1,1,1,1)
	self.segmentsList = ExRT.lib.CreateScrollCheckList(self:GetName().."SegmentsList",self.tab.tabs[4],nil,7,-25,280,8)
	self.segmentsList.Update()
	function self.segmentsList:ValueChanged()
		table_wipe(module.db.fightData.damage)
		table_wipe(module.db.fightData.switch)
		table_wipe(module.db.fightData.npc_cast)
		table_wipe(module.db.fightData.interrupts)
		table_wipe(module.db.fightData.dispels)
		table_wipe(module.db.fightData.buffs)
		table_wipe(module.db.fightData.dies)
		local count = 0
		for i=1,#self.L do
			if self.C[i] then
				AddSegmentToData(i)
				count = count + 1
			end
		end
		UpdateBuffPageDB()
		UpdatePage()
		if count == #self.L then
			for i=1,#module.options.buffs.timeSegments do
				module.options.buffs.timeSegments[i]:Hide()
			end
			for i=1,#module.options.timeLine.timeSegments do
				module.options.timeLine.timeSegments[i]:Hide()
			end
		else
			local fightDuration = (module.db.encounterEnd - module.db.encounterStart)
			for i=1,#self.L do
				CreateBuffSegmentBack(i)
				if self.C[i] then
					local timeStart = max(module.db.fightData[i].timeEx - module.db.encounterStart,0)
					local timeEnd = max(module.db.fightData[i+1] and (module.db.fightData[i+1].timeEx - module.db.encounterStart) or fightDuration,0)
					local startPos = 100+timeStart/fightDuration*470
					local endPos = 100+timeEnd/fightDuration*470
					module.options.buffs.timeSegments[i]:SetPoint("TOPLEFT",startPos,-42)
					module.options.buffs.timeSegments[i]:SetSize(max(endPos-startPos,0.5),374)
					module.options.buffs.timeSegments[i]:Show()
					
					module.options.timeLine.timeSegments[i]:Hide()
				else
					module.options.buffs.timeSegments[i]:Hide()
					
					local timeStart = max(module.db.fightData[i].timeEx - module.db.encounterStart,0)
					local timeEnd = max(module.db.fightData[i+1] and (module.db.fightData[i+1].timeEx - module.db.encounterStart) or fightDuration,0)
					local tlWidth = module.options.timeLine:GetWidth()
					local startPos = timeStart/fightDuration*tlWidth
					local endPos = timeEnd/fightDuration*tlWidth
					module.options.timeLine.timeSegments[i]:SetPoint("TOPLEFT",startPos,0)
					module.options.timeLine.timeSegments[i]:SetSize(max(endPos-startPos,0.5),module.options.timeLine:GetHeight())
					module.options.timeLine.timeSegments[i]:Show()
				end
			end
			for i=(#self.L + 1),#module.options.buffs.timeSegments do
				module.options.buffs.timeSegments[i]:Hide()
			end
			for i=(#self.L + 1),#module.options.timeLine.timeSegments do
				module.options.timeLine.timeSegments[i]:Hide()
			end
		end
	end
	self.segmentsButtonAll = ExRT.lib.CreateButton(nil,self.tab.tabs[4],100,15,nil,80,-8,ExRT.L.panelBossWatcherSegmentSelectAll)
	self.segmentsButtonAll:SetScript("OnClick",function ()
		for i=1,#module.options.segmentsList.L do
			module.options.segmentsList.C[i] = true
		end
		module.options.segmentsList.Update()
		module.options.segmentsList.ValueChanged(module.options.segmentsList)
	end)
	self.segmentsButtonNone = ExRT.lib.CreateButton(nil,self.tab.tabs[4],100,15,nil,185,-8,ExRT.L.panelBossWatcherSegmentSelectNothing)
	self.segmentsButtonNone:SetScript("OnClick",function ()
		for i=1,#module.options.segmentsList.L do
			module.options.segmentsList.C[i] = nil
		end
		module.options.segmentsList.Update()
		module.options.segmentsList.ValueChanged(module.options.segmentsList)
	end)
	
	self.segmentsTooltip = ExRT.lib.CreateText(self.tab.tabs[4],280,250,nil,297,-10,"LEFT","TOP",nil,12,ExRT.L.panelBossWatcherSegmentsTooltip,nil,nil,nil,nil,1)
	

	local function EditSliderBoxFunc(self,i)
		self.selected = self.selected + i
		if self.selected < 1 then 
			self.selected = #module.db.autoSegmentEvents
		elseif self.selected > #module.db.autoSegmentEvents then
			self.selected = 1
		end
		self.t:SetText(module.db.autoSegmentEventsL[module.db.autoSegmentEvents[self.selected]])
		self.tooltipText = module.db.autoSegmentEvents[self.selected]
		VExRT.BossWatcher.autoSegments[self.id] = VExRT.BossWatcher.autoSegments[self.id] or {}
		VExRT.BossWatcher.autoSegments[self.id][2] = module.db.autoSegmentEvents[self.selected]	
		UpdateNewSegmentEvents()  
	end

	self.autoSegments = {}
	for i=1,10 do
		self.autoSegments[i] = ExRT.lib.CreateEditBox(nil,self.tab.tabs[4],235,24,nil,10,-172-(i-1)*24,ExRT.L.panelBossWatcherSegmentsSpellTooltip,6,true,nil,VExRT.BossWatcher.autoSegments[i] and VExRT.BossWatcher.autoSegments[i][1] or "")
		self.autoSegments[i]:SetScript("OnTextChanged",function(self)
			VExRT.BossWatcher.autoSegments[i] = VExRT.BossWatcher.autoSegments[i] or {}
			VExRT.BossWatcher.autoSegments[i][1] = tonumber(self:GetText())
			UpdateNewSegmentEvents()
		end)

		self.autoSegments[i].t = ExRT.lib.CreateEditSliderBox(self.tab.tabs[4],328,24,256,-172-(i-1)*24,VExRT.BossWatcher.autoSegments[i] and VExRT.BossWatcher.autoSegments[i][2] and module.db.autoSegmentEventsL[VExRT.BossWatcher.autoSegments[i][2]] or module.db.autoSegmentEventsL[module.db.autoSegmentEvents[1]])
		self.autoSegments[i].t.l[1]:SetScript("OnClick",function() EditSliderBoxFunc(module.options.autoSegments[i].t,-1) end)
		self.autoSegments[i].t.l[2]:SetScript("OnClick",function() EditSliderBoxFunc(module.options.autoSegments[i].t,1) end)
		self.autoSegments[i].t.id = i
		self.autoSegments[i].t.tooltipText = VExRT.BossWatcher.autoSegments[i] and VExRT.BossWatcher.autoSegments[i][2] or module.db.autoSegmentEvents[1]
	end

	
	self.clearButton = CreateFrame("Button",self:GetName().."ButtonRemove",self,"UIPanelCloseButton") 
	self.clearButton:SetSize(18,18) 
	self.clearButton:SetPoint("TOPRIGHT",-10,-7) 
	self.clearButton.tooltipText = ExRT.L.panelBossWatcherClear
	self.clearButton:SetScript("OnClick", function() 
		table_wipe(module.db.guidsList)
		table_wipe(module.db.fightData)
		NewSegment(nil,nil,true)
		
		module.db.encounterName = ""
		module.db.encounterStart = 0
		module.db.encounterEnd = 0
		module.db.encounterStartGlobal = 0
		
		module.db.lastFightID = module.db.lastFightID + 1
		
		UpdatePageNewFight()
		UpdateBuffPageDB()
		UpdatePage()
	end) 
	self.clearButton:SetScript("OnEnter",function(self) ExRT.lib.OnEnterTooltip(self) end)
	self.clearButton:SetScript("OnLeave",function() ExRT.lib.OnLeaveTooltip() end)
	
	function UpdatePage()
		table.wipe(self.targetsList.L)
		table.wipe(module.options.targetsIndex)
		local mobsList = {}
		for mobGUID,mobData in pairs(module.db.fightData.damage) do
			table.insert(mobsList,{module.db.guidsList[mobGUID] or ExRT.L.panelBossWatcherUnknown,mobData.id,mobGUID})
		end
		table.sort(mobsList,function(a,b) return a[2] < b[2] end)
		for i=1,#mobsList do
			self.targetsList.L[i] = mobsList[i][1] .. date(" %M:%S", timestampToFightTime(mobsList[i][2]))
			module.options.targetsIndex[i] = mobsList[i][3]
		end
		
		if self.targetsList.dataIndex ~= module.db.encounterStart then
			self.targetsList.selected = nil
			module.options.damgeBox.EditBox:SetText("")
			module.options.switchBox.EditBox:SetText("")
			self.damgeSwitchTab.text:SetText("")
		end
		self.targetsList.dataIndex = module.db.encounterStart
		
		-->
		self.timeLine.textLeft:SetText( date("%H:%M:%S", module.db.encounterStartGlobal) )
		self.timeLine.textRight:SetText( date("%M:%S", module.db.encounterEnd - module.db.encounterStart) )
		self.timeLine.textCenter:SetText( date("%M:%S", (module.db.encounterEnd - module.db.encounterStart) / 2) )
		
		local fight_dur = module.db.encounterEnd - module.db.encounterStart
		self.timeLine.bossName:SetText( (module.db.encounterName or ExRT.L.panelBossWatcherLastFight)..date(" %M:%S", fight_dur ) )

		
		-->
		local redLineNum = 0
		for i=1,20 do
			if not self.timeLine[i].tooltip then
				self.timeLine[i].tooltip = {}
			end
			table_wipe(self.timeLine[i].tooltip)
		end
		for mobGUID,mobData in pairs(module.db.fightData.npc_cast) do
			for i=1,#mobData do
				local _time = timestampToFightTime(mobData[i][1])
				
				local tooltipIndex = _time / fight_dur
				
				redLineNum = redLineNum + 1
				if not self.timeLine.redLine[redLineNum] then
					CreateRedLine(redLineNum)
				end
				self.timeLine.redLine[redLineNum]:SetPoint("TOPLEFT",self.timeLine,"TOPLEFT",600*tooltipIndex,0)
				self.timeLine.redLine[redLineNum]:Show()
				
				tooltipIndex = floor( 19.99*tooltipIndex + 1 )
				
				local spellName,_,spellTexture = GetSpellInfo(mobData[i][2])
				
				local targetInfo = ""
				local sourceClass,targetClass
				if mobData[i][4] and module.db.guidsList[mobData[i][4]] and mobData[i][4] ~= "" then
					targetInfo = " "..ExRT.L.panelBossWatcherTimeLineOnText.." "..module.db.guidsList[mobData[i][4]]
					if mobData[i][4] ~= "" then
						targetClass = select(2,GetPlayerInfoByGUID(mobData[i][4]))
					end
					targetClass = targetClass or ""
					targetInfo = "|c".. ExRT.mds.classColor(targetClass)  .. targetInfo .. "|r"
				end
				if mobGUID ~= "" then
					sourceClass = select(2,GetPlayerInfoByGUID(mobGUID))
				end
				sourceClass = sourceClass or ""
				
				table.insert(self.timeLine[tooltipIndex].tooltip,{"|c"..ExRT.mds.classColor(sourceClass) .. module.db.guidsList[mobGUID] .."|r" .. GUIDtoText("(%s)",mobGUID) .. ( mobData[i][3] == 2 and " "..ExRT.L.panelBossWatcherTimeLineCast.." " or " "..ExRT.L.panelBossWatcherTimeLineCastStart.." " ) .. format("%s%s",spellTexture and "|T"..spellTexture..":0|t " or "",spellName or "???") .. targetInfo .. " [" .. date("%M:%S", _time )  .. "]",1,1,1})
			end
		end
		for i=(redLineNum+1),#self.timeLine.redLine do
			self.timeLine.redLine[i]:Hide()
		end
		
		local blueLineNum = 0
		for i=1,#module.db.fightData.dies do
			if ExRT.mds.GetUnitInfoByUnitFlag(module.db.fightData.dies[i][2],1) == 1024 then
				local _time = timestampToFightTime(module.db.fightData.dies[i][3])
				
				local tooltipIndex = _time / fight_dur
				
				blueLineNum = blueLineNum + 1
				if not self.timeLine.blueLine[blueLineNum] then
					CreateBlueLine(blueLineNum)
				end
				self.timeLine.blueLine[blueLineNum]:SetPoint("TOPLEFT",self.timeLine,"TOPLEFT",600*tooltipIndex,0)
				self.timeLine.blueLine[blueLineNum]:Show()
				
				tooltipIndex = floor( 19.99*tooltipIndex + 1 )
				
				table.insert(self.timeLine[tooltipIndex].tooltip, "|cffee5555" .. module.db.guidsList[module.db.fightData.dies[i][1]] .. GUIDtoText("(%s)",module.db.fightData.dies[i][1])  .. " "..ExRT.L.panelBossWatcherTimeLineDies.."|r [" .. date("%M:%S", _time )  .. "]")
			end
		end
		for i=(blueLineNum+1),#self.timeLine.blueLine do
			self.timeLine.blueLine[i]:Hide()
		end
		
		local textResult = ""
		for i=1,#module.db.fightData.interrupts do
			local spellSourceName,_,spellSourceTexture = GetSpellInfo(module.db.fightData.interrupts[i][3])
			local spellDestName,_,spellDestTexture = GetSpellInfo(module.db.fightData.interrupts[i][4])
			textResult = textResult.."[".. date("%M:%S", timestampToFightTime(module.db.fightData.interrupts[i][5])).."] " .. module.db.guidsList[module.db.fightData.interrupts[i][1]] .. GUIDtoText("(%s)",module.db.fightData.interrupts[i][1]) .. " "..ExRT.L.panelBossWatcherInterruptText.." " .. module.db.guidsList[module.db.fightData.interrupts[i][2]] .. GUIDtoText("(%s)",module.db.fightData.interrupts[i][2]) .. "'s " .. format("%s%s",spellDestTexture and "|T"..spellDestTexture..":0|t " or "",spellDestName or "???") .. " "..ExRT.L.panelBossWatcherByText.." " .. format("%s%s",spellSourceTexture and "|T"..spellSourceTexture..":0|t " or "",spellSourceName or "???") .. "\n"
		end
		module.options.interruptBox.EditBox:SetText(textResult)
		
		textResult = ""
		for i=1,#module.db.fightData.dispels do
			local spellSourceName,_,spellSourceTexture = GetSpellInfo(module.db.fightData.dispels[i][3])
			local spellDestName,_,spellDestTexture = GetSpellInfo(module.db.fightData.dispels[i][4])
			textResult = textResult.."[".. date("%M:%S", timestampToFightTime(module.db.fightData.dispels[i][5])).."] " .. module.db.guidsList[module.db.fightData.dispels[i][1]] .. GUIDtoText("(%s)",module.db.fightData.dispels[i][1]) .. " "..ExRT.L.panelBossWatcherDispelText.." " .. module.db.guidsList[module.db.fightData.dispels[i][2]] .. GUIDtoText("(%s)",module.db.fightData.dispels[i][2]) .. "'s " ..  format("%s%s",spellDestTexture and "|T"..spellDestTexture..":0|t " or "",spellDestName or "???") .. " "..ExRT.L.panelBossWatcherByText.." " .. format("%s%s",spellSourceTexture and "|T"..spellSourceTexture..":0|t " or "",spellSourceName or "???") .. "\n"
		end
		module.options.dispelBox.EditBox:SetText(textResult)
		
		self.targetsList.Update()
		
		-->
		UpdateBuffsPage()
		
	end
	
	self.lastFightIDPage = 0
	
	function UpdatePageNewFight()
		if self.lastFightIDPage ~= module.db.lastFightID then
			self.lastFightIDPage = module.db.lastFightID
			
			self.timeLine.arrowNow:Hide()
			
			-->
			table_wipe(self.segmentsList.L)
			table_wipe(self.segmentsList.C)
			if module.db.encounterStart ~= 0 then
				for i=1,module.db.fightData.segments or 0 do
					local time = module.db.fightData[i].time - module.db.encounterStartGlobal
					local name = module.db.fightData[i].name
					local subEvent = module.db.fightData[i].subEvent
					if name then
						name = " "..(module.db.segmentsLNames[name] or name)
						if subEvent then
							name = name.." <"..subEvent..">"
						end
					end
					self.segmentsList.L[i] = date("%M:%S", max(time,0)) .. (name or "")
				end
				if module.db.fightData.segments then
					self.segmentsList.C[module.db.fightData.segments] = true
				end
			end
			self.segmentsList.Update()
			self.segmentsList.ValueChanged(self.segmentsList)
		end
	end
	
	self.timeLine:SetScript("OnShow",function (this)
		if fightUV then
			module.db.encounterEnd = GetTime()
			local randomID = math.random(module.db.lastFightID+1,99999)
			self.lastFightIDPage = randomID
			self.tab.tabs[3].lastFightID = randomID
		end
	
		UpdatePageNewFight()
		UpdatePage()
	end)
	
	UpdatePageNewFight()
	UpdatePage()
end

local function addDamage(sourceGUID,destGUID,amount,timestamp)
	sourceGUID = sourceGUID or 0
	if not fightUV.damage[destGUID] then
		fightUV.damage[destGUID] = {
			['id']=timestamp,
			['d']={},
		}
	end
	if not fightUV.damage[destGUID]['d'][sourceGUID] then
		fightUV.damage[destGUID]['d'][sourceGUID] = 0
	end
	fightUV.damage[destGUID]['d'][sourceGUID] = fightUV.damage[destGUID]['d'][sourceGUID] + amount
end

local function addSwitch(sourceGUID,targetGUID,timestamp,_type)
	sourceGUID = sourceGUID or 0
	if not fightUV.switch[targetGUID] then
		fightUV.switch[targetGUID] = {
			[1]={},	--cast
			[2]={},	--target
		}
	end
	if not fightUV.switch[targetGUID][_type][sourceGUID] then
		fightUV.switch[targetGUID][_type][sourceGUID] = timestamp
	end
end

local function addNPCCast(sourceGUID,destGUID,spellID,_type,timestamp)
	if not fightUV.npc_cast[sourceGUID] then
		fightUV.npc_cast[sourceGUID] = {}
	end
	fightUV.npc_cast[sourceGUID][ #fightUV.npc_cast[sourceGUID] + 1 ] = {timestamp,spellID,_type,destGUID}
end

local function addGUID(GUID,name)
	if GUID and not module.db.guidsList[GUID] and name then
		module.db.guidsList[GUID] = name
	end
end

local function addBuff(timestamp,sourceGUID,destGUID,sourceFriendly,destFriendly,spellID,type_1,subeventID,stack)
	fightUV.buffs[ #fightUV.buffs + 1 ] = {timestamp,sourceGUID,destGUID,sourceFriendly,destFriendly,spellID,type_1,subeventID,stack}
end

function AddSegmentToData(seg)
	for destGUID,destData in pairs(module.db.fightData[seg].damage) do
		if not module.db.fightData.damage[destGUID] then
			module.db.fightData.damage[destGUID] = {
				['id']=destData.id,
				['d']={},
			}
		end
		for sourceGUID,amount in pairs(destData.d) do
			if not module.db.fightData.damage[destGUID]['d'][sourceGUID] then
				module.db.fightData.damage[destGUID]['d'][sourceGUID] = 0
			end
			module.db.fightData.damage[destGUID]['d'][sourceGUID] = module.db.fightData.damage[destGUID]['d'][sourceGUID] + amount
		end
	end
	for targetGUID,destData in pairs(module.db.fightData[seg].switch) do
		if not module.db.fightData.switch[targetGUID] then
			module.db.fightData.switch[targetGUID] = {
				[1]={},	--cast
				[2]={},	--target
			}
		end
		for _type=1,2 do
			for unitN,t in pairs(destData[_type]) do
				if not module.db.fightData.switch[targetGUID][_type][unitN] then
					module.db.fightData.switch[targetGUID][_type][unitN] = t
				end
				module.db.fightData.switch[targetGUID][_type][unitN] = min(t,module.db.fightData.switch[targetGUID][_type][unitN])
			end
		end
	end
	for sourceGUID,destData in pairs(module.db.fightData[seg].npc_cast) do
		if not module.db.fightData.npc_cast[sourceGUID] then
			module.db.fightData.npc_cast[sourceGUID] = {}
		end
		for i=1,#destData do
			local added_index = #module.db.fightData.npc_cast[sourceGUID] + 1
			module.db.fightData.npc_cast[sourceGUID][added_index] = {}
			for j=1,#destData[i] do
				module.db.fightData.npc_cast[sourceGUID][added_index][j] = destData[i][j]
			end
		end
	end
	for i=1,#module.db.fightData[seg].buffs do
		local added_index = #module.db.fightData.buffs + 1
		module.db.fightData.buffs[added_index] = {}
		for j=1,#module.db.fightData[seg].buffs[i] do
			module.db.fightData.buffs[added_index][j] = module.db.fightData[seg].buffs[i][j]
		end
	end
	for i=1,#module.db.fightData[seg].dies do
		local added_index = #module.db.fightData.dies + 1
		module.db.fightData.dies[added_index] = {}
		for j=1,#module.db.fightData[seg].dies[i] do
			module.db.fightData.dies[added_index][j] = module.db.fightData[seg].dies[i][j]
		end
	end
	for i=1,#module.db.fightData[seg].dispels do
		local added_index = #module.db.fightData.dispels + 1
		module.db.fightData.dispels[added_index] = {}
		for j=1,#module.db.fightData[seg].dispels[i] do
			module.db.fightData.dispels[added_index][j] = module.db.fightData[seg].dispels[i][j]
		end
	end
	for i=1,#module.db.fightData[seg].interrupts do
		local added_index = #module.db.fightData.interrupts + 1
		module.db.fightData.interrupts[added_index] = {}
		for j=1,#module.db.fightData[seg].interrupts[i] do
			module.db.fightData.interrupts[added_index][j] = module.db.fightData[seg].interrupts[i][j]
		end
	end		
end

function NewSegment(name,subEvent,afterClear)
	if not fightUV and not afterClear then
		return
	end
	
	if afterClear then
		module.db.fightData.segments = 0
	
		module.db.fightData.damage = {}
		module.db.fightData.switch = {}
		module.db.fightData.npc_cast = {}
		module.db.fightData.interrupts ={}
		module.db.fightData.dispels = {}
		module.db.fightData.buffs = {}
		module.db.fightData.dies = {}
	end

	module.db.fightData.segments = module.db.fightData.segments and module.db.fightData.segments + 1 or 1
	local seg = module.db.fightData.segments
	module.db.fightData[seg] = {}
	
	module.db.fightData[seg].damage = {}
	module.db.fightData[seg].switch = {}
	module.db.fightData[seg].npc_cast = {}
	module.db.fightData[seg].interrupts = {}
	module.db.fightData[seg].dispels = {}
	module.db.fightData[seg].buffs = {}
	module.db.fightData[seg].dies = {}
	module.db.fightData[seg].time = time()
	module.db.fightData[seg].timeEx = GetTime()
	module.db.fightData[seg].name = name
	module.db.fightData[seg].subEvent = subEvent
	
	if afterClear and not name then
		return
	end
	fightUV = module.db.fightData[seg]
end

function module.main:ADDON_LOADED()
	VExRT = VExRT or {}
	VExRT.BossWatcher = VExRT.BossWatcher or {}
	VExRT.BossWatcher.autoSegments = VExRT.BossWatcher.autoSegments or {}
	
	if VExRT.BossWatcher.enabled then
		module:Enable()
	end
end

function module.main:ENCOUNTER_START(encounterID,encounterName)
	table.wipe(module.db.guidsList)
	table.wipe(module.db.fightData)
	
	module.db.timeFix = nil
	module.db.encounterName = encounterName
	module.db.encounterStart = GetTime()
	module.db.encounterStartGlobal = time()
	
	module.db.encounterEnd = module.db.encounterStart
	
	module.db.lastFightID = module.db.lastFightID + 1
	
	addGUID("",ExRT.L.panelBossWatcherUnknown)
	addGUID(0,ExRT.L.panelBossWatcherUnknown)
	
	NewSegment("ENCOUNTER_START",nil,true)
	
	for event,_ in pairs(module.db.registerOtherEvents) do
		module:RegisterEvents(event)
	end
	module:RegisterEvents('COMBAT_LOG_EVENT_UNFILTERED','UNIT_TARGET')
end
module.main.PLAYER_REGEN_DISABLED = module.main.ENCOUNTER_START

function module.main:ENCOUNTER_END()
	module.db.encounterEnd = GetTime()

	module:UnregisterEvents('COMBAT_LOG_EVENT_UNFILTERED','UNIT_TARGET')
	for event,_ in pairs(module.db.registerOtherEvents) do
		module:UnregisterEvents(event)
	end
	fightUV = nil
end
module.main.PLAYER_REGEN_ENABLED = module.main.ENCOUNTER_END

function module.main:ZONE_CHANGED_NEW_AREA()
	ExRT.mds.dprint('ZONE_CHANGED_NEW_AREA')
	local zoneID = GetCurrentMapAreaID()
	
	module:UnregisterEvents('PLAYER_REGEN_DISABLED','PLAYER_REGEN_ENABLED','ENCOUNTER_START','ENCOUNTER_END')
	if module.db.raidIDs[zoneID] then
		module:RegisterEvents('ENCOUNTER_START','ENCOUNTER_END')
	else
		module:RegisterEvents('PLAYER_REGEN_DISABLED','PLAYER_REGEN_ENABLED')
	end
end

function module.main:UNIT_SPELLCAST_SUCCEEDED(unitID,_,_,_,spellID)
	if module.db.autoSegments.UNIT_SPELLCAST_SUCCEEDED[spellID] then
		NewSegment("UNIT_SPELLCAST_SUCCEEDED",spellID)
	end
end

function module.main:CHAT_MSG_RAID_BOSS_EMOTE(msg)
	for emote,_ in pairs(module.db.autoSegments.CHAT_MSG_RAID_BOSS_EMOTE) do
		if msg:find(emote, nil, true) or msg:find(emote) then
			NewSegment("CHAT_MSG_RAID_BOSS_EMOTE",emote)
		end
	end
end

function module.main:SPELL_DAMAGE(timestamp,sourceGUID,sourceName,sourceFlags,_,destGUID,destName,destFlags,_,spellId,_,_,amount)
	if not UnitIsFriendlyByUnitFlag(destFlags) then
		--amount, overkill, school, resisted, blocked, absorbed, critical, glancing, crushing, isOffHand, multistrike
		addDamage(sourceGUID,destGUID,amount,timestamp)
		
		--> switch
		addSwitch(sourceGUID,destGUID,timestamp,1)
	end
end
module.main.SPELL_PERIODIC_DAMAGE = module.main.SPELL_DAMAGE
module.main.RANGE_DAMAGE = module.main.SPELL_DAMAGE

function module.main:SWING_DAMAGE(timestamp,sourceGUID,sourceName,sourceFlags,sourceFlags2,destGUID,destName,destFlags,destFlags2,amount)
	if not UnitIsFriendlyByUnitFlag(destFlags) then
		--local overkill,_,resisted,blocked,absorbed = ...
		--amount, overkill, school, resisted, blocked, absorbed, critical, glancing, crushing, isOffHand, multistrike
		addDamage(sourceGUID,destGUID,amount,timestamp)
		
		--> switch
		addSwitch(sourceGUID,destGUID,timestamp,1)
	end
end

function module.main:SPELL_AURA_APPLIED(timestamp,sourceGUID,sourceName,sourceFlags,_,destGUID,destName,destFlags,_,spellId,_,_,_type)
	addBuff(timestamp,sourceGUID,destGUID,UnitIsFriendlyByUnitFlag(sourceFlags),UnitIsFriendlyByUnitFlag(destFlags),spellId,_type,1,1)
	
	if module.db.autoSegments.SPELL_AURA_APPLIED[spellId] then
		NewSegment("SPELL_AURA_APPLIED",spellId)
	end
end

function module.main:SPELL_AURA_REMOVED(timestamp,sourceGUID,sourceName,sourceFlags,_,destGUID,destName,destFlags,_,spellId,_,_,_type)
	addBuff(timestamp,sourceGUID,destGUID,UnitIsFriendlyByUnitFlag(sourceFlags),UnitIsFriendlyByUnitFlag(destFlags),spellId,_type,2,1)
	
	if module.db.autoSegments.SPELL_AURA_REMOVED[spellId] then
		NewSegment("SPELL_AURA_REMOVED",spellId)
	end
end

function module.main:SPELL_AURA_APPLIED_DOSE(timestamp,sourceGUID,sourceName,sourceFlags,_,destGUID,destName,destFlags,_,spellId,_,_,_type,stack)
	addBuff(timestamp,sourceGUID,destGUID,UnitIsFriendlyByUnitFlag(sourceFlags),UnitIsFriendlyByUnitFlag(destFlags),spellId,_type,3,stack)
end

function module.main:SPELL_AURA_REMOVED_DOSE(timestamp,sourceGUID,sourceName,sourceFlags,_,destGUID,destName,destFlags,_,spellId,_,_,_type,stack)
	addBuff(timestamp,sourceGUID,destGUID,UnitIsFriendlyByUnitFlag(sourceFlags),UnitIsFriendlyByUnitFlag(destFlags),spellId,_type,4,stack)
end

function module.main:SPELL_CAST_SUCCESS(timestamp,sourceGUID,sourceName,sourceFlags,_,destGUID,destName,destFlags,_,spellId)
	--> switch
	if not not UnitIsFriendlyByUnitFlag(destFlags) then
		addSwitch(sourceGUID,destGUID,timestamp,1)
	end
	
	--> npc cast
	if not UnitIsFriendlyByUnitFlag(sourceFlags) then
		addNPCCast(sourceGUID,destGUID,spellId,2,timestamp)
	end
end

function module.main:SPELL_CAST_START(timestamp,sourceGUID,sourceName,sourceFlags,_,destGUID,destName,destFlags,_,spellId)
	--> npc cast
	if not UnitIsFriendlyByUnitFlag(sourceFlags) then
		addNPCCast(sourceGUID,destGUID,spellId,1,timestamp)
	end
	
	--> switch
	if sourceName then
		local unitID = UnitInRaid(sourceName)
		if unitID then
			unitID = "raid"..unitID
			local targetGUID = UnitGUID(unitID.."target")
			if targetGUID and not UnitIsPlayerOrPet(targetGUID) then
				addSwitch(sourceGUID,targetGUID,timestamp,1)
			end
		end
	end
end

function module.main:UNIT_DIED(timestamp,sourceGUID,sourceName,sourceFlags,sourceFlags2,destGUID,destName,destFlags,destFlags2,spellId)
	fightUV.dies[#fightUV.dies+1] = {destGUID,destFlags,timestamp}
	
	local uID = tonumber(string_sub(destGUID or "?", -13, -9), 16) or 0
	if module.db.autoSegments.UNIT_DIED[ uID ] then
		NewSegment("UNIT_DIED",uID)
	end
end

function module.main:SPELL_INTERRUPT(timestamp,sourceGUID,sourceName,sourceFlags,sourceFlags2,destGUID,destName,destFlags,destFlags2,spellId,_,_,destSpell)
	fightUV.interrupts[#fightUV.interrupts+1]={sourceGUID,destGUID,spellId,destSpell,timestamp}
end

function module.main:SPELL_DISPEL(timestamp,sourceGUID,sourceName,sourceFlags,sourceFlags2,destGUID,destName,destFlags,destFlags2,spellId,_,_,destSpell)
	fightUV.dispels[#fightUV.dispels+1]={sourceGUID,destGUID,spellId,destSpell,timestamp}
end

function module.main:SPELL_RESURRECT(timestamp,sourceGUID,sourceName,sourceFlags,_,destGUID,destName,destFlags,_,spellId)
	addNPCCast(sourceGUID,destGUID,spellId,2,timestamp)
end

function module.main:UNIT_TARGET(unitID)
	local targetName = UnitName(unitID.."target")
	if targetName then
		local targetGUID = UnitGUID(unitID.."target")
		if not UnitIsPlayerOrPet(targetGUID) then
			local sourceGUID = UnitGUID(unitID)
			addSwitch(sourceGUID,targetGUID,GetTime(),2)
		end
	end
end

local CLEUEvents = {
	SPELL_PERIODIC_DAMAGE = module.main.SPELL_PERIODIC_DAMAGE,
	RANGE_DAMAGE = module.main.RANGE_DAMAGE,
	SPELL_DAMAGE = module.main.SPELL_DAMAGE,
	SWING_DAMAGE = module.main.SWING_DAMAGE,
	SPELL_AURA_APPLIED = module.main.SPELL_AURA_APPLIED,
	SPELL_AURA_REMOVED = module.main.SPELL_AURA_REMOVED,
	SPELL_AURA_APPLIED_DOSE = module.main.SPELL_AURA_APPLIED_DOSE,
	SPELL_AURA_REMOVED_DOSE = module.main.SPELL_AURA_REMOVED_DOSE,
	SPELL_CAST_SUCCESS = module.main.SPELL_CAST_SUCCESS,
	SPELL_CAST_START = module.main.SPELL_CAST_START,
	UNIT_DIED = module.main.UNIT_DIED,
	SPELL_INTERRUPT = module.main.SPELL_INTERRUPT,
	SPELL_DISPEL = module.main.SPELL_DISPEL,
	SPELL_RESURRECT = module.main.SPELL_RESURRECT,
}

function module.main:COMBAT_LOG_EVENT_UNFILTERED(timestamp,event,hideCaster,sourceGUID,sourceName,sourceFlags,sourceFlags2,destGUID,destName,destFlags,destFlags2,spellId,...)
	local eventFunc = CLEUEvents[event]
	if eventFunc then
		eventFunc(self,timestamp,sourceGUID,sourceName,sourceFlags,sourceFlags2,destGUID,destName,destFlags,destFlags2,spellId,...)
	end
	
	if not module.db.timeFix then
		module.db.timeFix = {GetTime(),timestamp}
	end
	
	addGUID(sourceGUID,sourceName)
	addGUID(destGUID,destName)
end

function module:slash(arg)
	if arg == "seg" then
		NewSegment("SLASH")
	end
end
ExRT.mds.BWNS = NewSegment